package annotation

import "reflect"

// Annotation is interface
type Annotation interface {
}

// AnnotationType is type of Annotation
var AnnotationType = reflect.TypeOf((*Annotation)(nil))

// TypeAnnotation is interface
type TypeAnnotation interface {
	Annotation
}

// TypeAnnotationType is type of TypeAnnotation
var TypeAnnotationType = reflect.TypeOf((*TypeAnnotation)(nil))

// MethodAnnotation is interface
type MethodAnnotation interface {
	Annotation
}

// MethodAnnotationType is type of MethodAnnotation
var MethodAnnotationType = reflect.TypeOf((*MethodAnnotation)(nil))
